@echo off

SET DB_ENGNAME=ULFoundation
SET DSN=%DB_ENGNAME%

REM -- Grab the current directory
SET SCRIPT_DIR=%_cwd%
IF "%SCRIPT_DIR%" == "" SET SCRIPT_DIR=%cd%
IF "%SCRIPT_DIR%" == "" FOR /f %%i IN ('cd') DO @SET SCRIPT_DIR=%%i
IF "%SCRIPT_DIR%" == "" CALL Win9x_curdir.bat

REM -- Grab the parent directory (the 'database' directory)
IF NOT EXIST "..\dat" md ..\dat
cd ..\dat
SET DB_DIR=%SCRIPT_DIR%\..\dat
SET DB_FILE=%DB_DIR%\%DB_ENGNAME%.db

cd %SCRIPT_DIR%

echo.
echo.
echo == Stopping database [%DB_ENGNAME%]
echo.
IF EXIST "%DB_FILE%" "%ASANY9%\win32\dbstop" -y -c "uid=dba;pwd=sql;"

echo.
echo.
echo == Erasing database [%DB_FILE%]
echo.
IF EXIST "%DB_FILE%" "%ASANY9%\win32\dberase" -y "%DB_FILE%"

IF NOT EXIST "%DB_FILE%" goto create_dsn
echo.
echo ERROR: Database [%DB_FILE%] was not erased
echo.
pause
goto the_end


:create_dsn
echo.
echo.
echo == Creating ODBC Data Source Name [%DSN%]
echo.
"%ASANY9%\win32\dbdsn" -du %DSN% -y
"%ASANY9%\win32\dbdsn" -v -wu %DSN% -c "UID=dba;PWD=sql;DBF=%DB_FILE%;ENG=%DB_ENGNAME%;START=dbeng9 -c 12m;AUTOSTOP=no;INT=no"

:create_db
echo.
echo.
echo == Creating the database [%DB_FILE%]
echo.
"%ASANY9%\win32\dbinit" "%DB_FILE%"

IF EXIST "%DB_FILE%" goto gen_schema
echo.
echo ERROR: The new database [%DB_FILE%] was not created
echo.
pause
goto the_end


:gen_schema
echo.
echo.
echo == Generate the database schema
echo.
"%ASANY9%\win32\dbisql" -c "dsn=%DSN%" read ..\sql\createASA.sql
IF errorlevel == 0 goto enter_data
echo.
echo ERROR: Could not create schema for: [%DB_FILE%]
echo        Try shutting down older versions of database engine.
echo.
pause
goto the_end


:enter_data
echo.
echo.
echo == Entering initial data into database
echo.
"%ASANY9%\win32\dbisql" -c "dsn=%DSN%" read ..\sql\data.sql
IF errorlevel == 0 goto add_sync_scripts
echo.
echo ERROR: Could not create data for: [%DB_FILE%]
echo.
pause
goto the_end

:add_sync_scripts
echo.
echo.
echo == Adding the synchronization scripts
echo.
"%ASANY9%\win32\dbisql" -c "dsn=%DSN%" read ..\sql\sync.sql

call ..\bin\genul9

echo.
echo.
echo == done. ==
echo.


:the_end
REM no more stuff to do
