Attribute VB_Name = "ULFoundation_DB"


 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' 
 '       Copyright (C) 2001-2003, by iAnywhere Solutions, Inc.         ' 
 '       All rights reserved. iAnywhere Solutions is a trademark       ' 
 '       of Sybase, Inc.  No part of this software may be              ' 
 '       reproduced in any form or by any means - graphic,             ' 
 '       electronic or mechanical, including photocopying,             ' 
 '       recording, taping or information storage and retrieval        ' 
 '       systems - except with the written permission of               ' 
 '       iAnywhere Solutions, Inc.                                     ' 
 '                                                                     ' 
 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' 

Option Explicit

Dim DatabaseMgr As ULDatabaseManager
Private conn_parms As String
Private open_parms As String
Private schema_parms As String
Private app_path As String

Public Connection As ULConnection
Public CustomerTable As ULTable

Public Sub Initialize()

#If appforge Then
    app_path = ""
#Else
    app_path = App.Path
#End If

    Set DatabaseMgr = New ULDatabaseManager

    conn_parms = "uid=DBA;pwd=SQL"
    open_parms = conn_parms & ";" & _
        "FILE_NAME=" & app_path & "\ULFoundation.udb;" & _
        "CE_FILE=\Program Files\ULFoundation\ULFoundation.udb;" & _
        "PALM_DB=AD32"
    schema_parms = open_parms & ";" & _
        "SCHEMA_FILE=" & app_path & "\..\..\..\sql\ULFoundation.usm;" & _
        "CE_SCHEMA=\Program Files\ULFoundation\ULFoundation.usm;" & _
        "PALM_SCHEMA=ul_foundsm"
        
End Sub

Public Function InitConnection() As Boolean

    On Error Resume Next

    Set Connection = DatabaseMgr.OpenConnection(open_parms)
    If Err.Number = ULSQLCode.ulSQLE_DATABASE_NOT_FOUND Then
        Err.Clear
        Set Connection = _
        DatabaseMgr.CreateDatabase(schema_parms)
        If Not Err.Number = ULSQLCode.ulSQLE_NOERROR Then
            InitConnection = False
            MsgBox Err.Description
            Exit Function '*** EXIT FUNCTION HERE ***
        End If
    End If

    InitConnection = True
    Connection.SyncParms.UserName = "user23"
    Connection.SyncParms.Version = "1.0"
    Connection.SyncParms.Stream = ulTCPIP

End Function

Public Sub InitCustomerTable()
    
    Set CustomerTable = Connection.GetTable("customer")
    CustomerTable.Open

End Sub

Public Function SynchronizeDB() As Integer
    
    If CustomerTable.IsOpen Then CustomerTable.Close
    
    'continue if an error occurs during the sync, this error
    'is reported in the Err.Number object
    On Error Resume Next
    Err.Clear
    Connection.Synchronize
    SynchronizeDB = Err.Number
    On Error GoTo 0
    
    CustomerTable.Open
End Function


Public Sub PopulateCustomerGrid(ByRef grdCustomer As AFGrid, _
                                ByRef ErrorLabel As AFLabel, _
                                ByVal HeaderHeightMul As Integer, _
                                ByVal IdColWidth As Integer)
    
    ErrorLabel.Caption = ""
    grdCustomer.Rows = 0
        
    If IdColWidth <= 0 Then
        IdColWidth = 20
    End If
    grdCustomer.ColWidth(0) = IdColWidth
    
    If HeaderHeightMul <= 0 Then
        HeaderHeightMul = 1
    End If
    
    'add the heading row to the grid
    grdCustomer.AddItem "ID" & Chr(9) & "FIRST NAME" & _
                        Chr(9) & "LAST NAME"
    grdCustomer.RowHeight(0) = grdCustomer.RowHeight(0) * _
                                    HeaderHeightMul
        
    Dim hasAtLeastOne As Boolean
    hasAtLeastOne = False
        
    Dim hasNext As Boolean
    hasNext = GetNextRow(grdCustomer)
    While hasNext
        hasNext = GetNextRow(grdCustomer)
        hasAtLeastOne = True
    Wend

    If Not hasAtLeastOne Then
        ErrorLabel.Caption = "No records to display, please synchronize."
    End If
    
End Sub


Private Function GetNextRow(ByRef grid As AFGrid) As Boolean

    'Get the next row from the cursor.
    If CustomerTable.IsOpen Then
        CustomerTable.MoveNext
    End If

    If CustomerTable.EOF Then
        'If we have run out of rows, return false
        GetNextRow = False
    Else
        'Add the information to the grid control
        grid.AddItem CustomerTable.Column("customer_id").StringValue & _
                     Chr(9) & _
                     CustomerTable.Column("first_name").StringValue & _
                     Chr(9) & _
                     CustomerTable.Column("last_name").StringValue
        GetNextRow = True
    End If

End Function

