/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2001-2003, by iAnywhere Solutions, Inc.         *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/




// Customer.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "CustomerView.h"
#include "ULDB.h"
#include "platform.h"
#include "UlfoundationDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomerView

IMPLEMENT_DYNCREATE( CCustomerView, CFormView )

CCustomerView::CCustomerView()
		: CFormView( CCustomerView::IDD )
{
	//{{AFX_DATA_INIT(CCustomerView)
	m_no_record_msg = _T( "" );
	//}}AFX_DATA_INIT
	//( ( CUlfoundationDoc* ) GetDocument() ) ->m_uldb.OpenCustomerCursor();
}

CCustomerView::~CCustomerView()
{
	//( ( CUlfoundationDoc* ) GetDocument() ) ->m_uldb.CloseCustomerCursor();
}

void CCustomerView::DoDataExchange( CDataExchange* pDX )
{
	CFormView::DoDataExchange( pDX );
	//{{AFX_DATA_MAP(CCustomerView)
	DDX_Control(pDX, IDC_CUSTOMER_LIST, m_customerList);
	DDX_Text( pDX, IDC_NO_RECORDS, m_no_record_msg );
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP( CCustomerView, CFormView )
//{{AFX_MSG_MAP(CCustomerView)
	ON_COMMAND(FILE_SYNC, OnSync)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomerView diagnostics

#ifdef _DEBUG
void CCustomerView::AssertValid() const
{
	CFormView::AssertValid();
}

void CCustomerView::Dump( CDumpContext& dc ) const
{
	CFormView::Dump( dc );
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCustomerView message handlers


void CCustomerView::ClearScreen()
{
	//set the member variables to the cursor data
	m_no_record_msg = _T( "" );
	
	//refresh the screen with the new data
	UpdateData( FALSE );
}


void CCustomerView::OnInitialUpdate() 
{
	CFormView ::OnInitialUpdate();
	
	SetCustomerListHeader();
}


void CCustomerView::OnDraw(CDC* pDC) 
{
	ClearScreen();
	PopulateCustomerList();
}


void CCustomerView::OnSync() 
{
	CWaitCursor cursor;  // starts and stops wait cursor just by instantiating
    long retcode;
    CString msg;

	// Pocket PC 2002 Emulator synchronization fix goes here

	retcode = ( ( CUlfoundationDoc* ) GetDocument() ) ->m_uldb.Synchronize();
	ClearScreen();

	if ( retcode == SQLE_NOERROR ) {
		msg = _T( "Synchronization was successful." );
		AfxMessageBox( msg, MB_OK | MB_ICONINFORMATION  );
	} else {
		msg.Format( _T( "Synchronization returned with an error: [%ld]"), retcode );
		AfxMessageBox( msg, MB_OK | MB_ICONERROR );
	}
	
	PopulateCustomerList();
}


void CCustomerView::PopulateCustomerList(void)
{
	m_customerList.DeleteAllItems();

	// attempt to populate the customer list w/ data
	ULDB & db = ( ( CUlfoundationDoc* ) GetDocument() ) ->m_uldb;
	long retcode = db.OpenCustomerCursor();

	CString msg;
	if ( retcode != SQLE_NOERROR ) {
		msg.Format( _T( "Opening cursor returned an error: [%ld]"), retcode );
		AfxMessageBox( msg, MB_OK | MB_ICONERROR );
	}

	customer_struct record;
	bool hasAtLeastOne = false;

	retcode = db.GetNextCustomerRecord( &record );
	int index = 0;

	while ( retcode == SQLE_NOERROR ) {
		CString id;
		id.Format( _T("%i"), record.customer_id );
		int ret = m_customerList.InsertItem( LVIF_TEXT, index, id, 0, -1, -1, NULL );
		m_customerList.SetItem( ret, 1, LVIF_TEXT, record.first_name, -1, -1, -1, NULL );
		m_customerList.SetItem( ret, 2, LVIF_TEXT, record.last_name, -1, -1, -1, NULL );

		// update for next loop iteration
		retcode = db.GetNextCustomerRecord( &record );
		hasAtLeastOne = true;
		index++;
	}

	if( !hasAtLeastOne ) {
		m_no_record_msg = _T( "No records to fetch, you might " );
		m_no_record_msg += _T( "try synchronizing." );
		UpdateData( FALSE );
	} else {
		m_no_record_msg = _T( "" );
		UpdateData( FALSE );
	}

	retcode = db.CloseCustomerCursor();

	if ( retcode != SQLE_NOERROR ) {
		msg.Format( _T( "Closing cursor returned an error: [%ld]"), retcode );
		AfxMessageBox( msg, MB_OK | MB_ICONERROR );
	}
}


void CCustomerView::SetCustomerListHeader(void) 
{
	m_customerList.InsertColumn( 0, _T("ID"), LVCFMT_LEFT, 25 );
	m_customerList.InsertColumn( 1, _T("FIRST NAME"), LVCFMT_LEFT, 80);
	m_customerList.InsertColumn( 2, _T("LAST NAME"), LVCFMT_LEFT, 80);
}
