/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2001-2003, by iAnywhere Solutions, Inc.         *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/




// ULFoundationDoc.h : interface of the CUlfoundationDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ULFOUNDATIONDOC_H__64F3C2E6_DD04_451C_8D2A_5B46CE07E833__INCLUDED_)
#define AFX_ULFOUNDATIONDOC_H__64F3C2E6_DD04_451C_8D2A_5B46CE07E833__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "ULDB.h"

/** This is the ULFoundation Document class. It handles creation and cleanup of the
	database and it's connection.
 */
class CUlfoundationDoc : public CDocument
{
protected: // create from serialization only

	/** Creates an instance of the ULFoundation CDocument, and initializes the
		database and it's connection.
	 */
	CUlfoundationDoc();
	DECLARE_DYNCREATE(CUlfoundationDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	

	//the following doc++ comment is for virtual BOOL OnNewDocument().
	//it couldn't directly preceed the function declaration because
	//the //{{ //}} block doesn't accept /** comments
	/** Runs when this class is reinitialized.

		@return true if the Document was reinitialized without errors, false
		otherwise.
	 */
	
	//{{AFX_VIRTUAL(CUlfoundationDoc)
	public:

	virtual BOOL OnNewDocument();

	///Handles serialization of this class.
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:

	/** Static instance of the UltraLite database.
	 */
	static ULDB m_uldb;

	/** Cleans up the ULFoundation CDocument, and closes the database and it's
		connection.
	 */
	virtual ~CUlfoundationDoc();

#ifdef _DEBUG

	/** Automatically generated eVC debug method.
	 */
	virtual void AssertValid() const;

	/** Automatically generated eVC debug method.
	 */
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CUlfoundationDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations
//immediately before the previous line.

#endif 
// !defined(AFX_ULFOUNDATIONDOC_H__64F3C2E6_DD04_451C_8D2A_5B46CE07E833__INCLUDED_)
