/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2001-2003, by iAnywhere Solutions, Inc.          *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/



#ifndef _PLATFORM_H_INCLUDED
#define _PLATFORM_H_INCLUDED

#if defined( __QNXNTO__ ) || defined( UNDER_DOS )
#ifndef bool
    typedef char        bool;
    #define true        ((bool)1)
    #define false       ((bool)0)
    #define TRUE        ((bool)1)
    #define FALSE       ((bool)0)
#endif
#endif

#if defined( __MWERKS__ )

    // Palm OS
    // #includes use a macro to prevent VC++ from complaining about missing files
    #define _MW_MEMORYMGR_H <MemoryMgr.h>
    #include _MW_MEMORYMGR_H
    #include <string.h>
    #define _MW_STRINGMGR_H <StringMgr.h>
    #include _MW_STRINGMGR_H

	typedef		char							TCHAR;
    //#define     TCHAR                           char

    // CE and NT make a lot of use of _T()
    #define     _T(s)                           _TEXT(s)
    #define     _TEXT(s)                        s

    #define     my_itoa(a, b, c)                StrIToA(a, b)
    #define     my_atoi(a)                      StrAToI(a)
    #define     my_sprintf                      StrPrintF
    #define     my_strcmp(a, b)                 StrCompare(a, b)
    #define     my_strcpy(a, b)                 StrCopy(a, b)
    #define     my_strcat(a, b)                 StrCat(a, b)
    #define     my_strlen(a)                    StrLen(a)
    #define     my_strncpy(a, b, c)             StrNCopy(a, b, c)
    #define     my_strncat(a, b, c)             StrNCat(a, b, c)
    #define     my_memset(a, b, c)              MemSet(a, b, c)
    #define     my_memmove(a, b, c)             MemMove(a, b, c)
    #define     my_memcpy(a, b, c)              MemMove(a, b, c)
    #define     my_malloc(a)                    MemPtrNew(a)
    #define     my_free(a)                      MemPtrFree(a)

#elif defined( UNDER_EPOC )
    #include <stdlib.h>
    #include <string.h>

    #define     TCHAR                           char
    #define     _TEXT(s)                        s

    #define     my_strcpy(a, b)                 strcpy(a, b)
    #define     my_malloc(a)                    malloc(a)
    #define     my_free(a)                      free(a)

#elif defined( UNDER_RIM )

    #include <stdlib.h>
    #include <string.h>
    #include <tchar.h>
    #include "pager.h"

    #define my_malloc(a)                RimMalloc(a)
    #define my_free(a)                  RimFree(a)
    #define ULSocketStream              ULSerialStream
    #define my_strcpy(a, b)             _tcscpy(a, b)
        
#elif defined( UNDER_VXW )

    #include <stdlib.h>
    #include <string.h>

    #define TCHAR                       char
    #define _TEXT(s)                    s

    #define my_malloc(a)                malloc(a)
    #define my_free(a)                  free(a)
    #define my_strcpy(a, b)             strcpy(a, b)
    #define my_strncpy(a, b, c)         strcpy(a, b)
    
#else

    // Windows NT or Windows CE
    #include <stdlib.h>
    #include <string.h>
    #include <tchar.h>
    #include <stdio.h>  // needed for sprintf()

    // Some versions of CE do not define _TEXT
    #ifndef _TEXT
        #define _TEXT(s)                TEXT(s)
    #endif

    #define     my_itoa(a, b, c)        itoa(a, b, c)
    #define     my_atoi(a)              _ttoi(a)
    #define     my_sprintf              _stprintf
    #define     my_strcmp(a, b)         _tcscmp(a, b)
    #define     my_strcpy(a, b)         _tcscpy(a, b)
    #define     my_strlen(a)            _tcslen(a)
    #define     my_strncpy(a, b, c)     _tcsncpy(a, b, c)
    #define     my_strncat(a, b, c)     _tcsncat(a, b, c)
    #define     my_memset(a, b, c)      memset(a, b, c)
    #define     my_memmove(a, b, c)     memmove(a, b, c)
    #define     my_memcpy(a, b, c)      MemMove(a, b, c)
    #define     my_malloc(a)            malloc(a)
    #define     my_free(a)              free(a)
    
#endif

#endif
