/*##COPYRIGHT
***********************************************************************
*       Copyright (C) 2001-2003, by iAnywhere Solutions, Inc.         *
*       All rights reserved. iAnywhere Solutions is a trademark       *
*       of Sybase, Inc.  No part of this software may be              *
*       reproduced in any form or by any means - graphic,             *
*       electronic or mechanical, including photocopying,             *
*       recording, taping or information storage and retrieval        *
*       systems - except with the written permission of               *
*       iAnywhere Solutions, Inc.                                     *
*                                                                     *
***********************************************************************
#*/

import java.awt.*;
import java.util.StringTokenizer;

/**
 * Internal helper class which creates a multiline label.
 *
 */
class InnerMultilineLabel extends Panel {

    /**
     * Creates a new multi-line label.
     *
     * @param s The string to display in this label. To create a
     * multiline message, use '\n' as the end-of-line character.
     */
    public InnerMultilineLabel( String s ) {

	// Stuff the string in a tokenizer to get at each line...
	StringTokenizer st = new StringTokenizer( s, "\n" );
	int tCount = st.countTokens();

	// Make a grid...
	setLayout( new GridLayout( tCount + 2, 1, 0, 0 ) );

	// Leave some space...
	add( new Label( " " ) );

	// Make each line a new label and add to layout...
	for( int i = 0; i < tCount; i++ ) {
	    add( new Label( st.nextToken() ) );
	}

	// Leave some space...
	add( new Label( " " ) );
    }
}
