/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2001-2003, by iAnywhere Solutions, Inc.         *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/





#ifndef __FIRSTFORM_H__    // make sure we only include this code once
#define __FIRSTFORM_H__

#include "platform.h"
#include "Main.h"
#include "PalmFunctions.h"
#include "ULFoundation_res.h"
#include "ULFoundationAPI.hpp"

/** The maximum length of an ID number.
 */
#define ID_NUMBER_LEN  (10)

/** The maximum length of a customer's first name.
 */
#define FIRST_NAME_LEN   (20)
/** The maximum length of a customer's last name.
 */
#define LAST_NAME_LEN    (30)

/** Initializes the First form.

	@param pForm A pointer to the form to be initialized.
 */
void FirstFormInit( FormPtr pForm );

/** Cleans up the First form.

	@param pForm A pointer to the form to be cleaned up.
 */
void FirstFormFini( FormPtr pForm );

/** Handles menu commands associated with the First form.

	@param command The menu command to be handled.
	
	@return true if the menu command was handled and does not need to be passed
	to another handler function, false otherwise.
 */
Boolean FirstFormHandleMenu( Word command );

/** Handles all form events, such as button clicks and screen taps.

	@param pEvent A pointer to the event to be handled.
	
	@return true if the menu command was handled and does not need to be passed
	to another handler function, false otherwise.
 */
Boolean FirstFormHandleEvent( EventPtr pEvent );

/** Synchronizes the ultralite database and populates the TablePtr resource
    with data.
    
    @param pForm A pointer to the First form to set display info
 */
void Synchronize( FormPtr pForm );


/** Populates the TablePtr resource with the data held by the ultralite database. 

	@param pForm A pointer to the First form. 
 */
void PopulateTable( FormPtr pForm );

/** The custom draw procedure used to draw the text in the cells of the table. 

	@param  pTable  the TablePtr resource
	@param  row     the row number of the cell
	@param  col     the column number of the cell
	@param  bounds  a RectangleType pointer defining the bounds of the cell
 */
void DrawTableCell( void * pTable, Int16 row, Int16 col, RectangleType *bounds );

/** Returns the length of a TCHAR* needed for the specified column.

	@param  col  the column index
	@return int  the length of a TCHAR * assigned to that column. 
 */
int ColTextLength( int col );



#endif