/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2001-2003, by iAnywhere Solutions, Inc.         *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/




#ifndef __MAIN_H__    // make sure we only include this code once
#define __MAIN_H__

// For future reference:
// 0x2301 is Code Warrior 6
// 0x2401 is Code Warrior 7
// 0x2402 is Code Warrior 8
#if __MWERKS__ >= 0x2401
#include "ulpalm35.h"

#else
#include "ulpalm31.h"

#endif

#include "platform.h"
#include "ULFoundation_res.h"  // header file generated from ULFoundation.rsrc
#include "ULDB.h"
#include "FirstForm.h"

/** A pointer to the UltraLite database object.
 */
extern ULDB *pULDB;

/** This function is called whenever we change forms.  It loads the new form
	resources and set the event handler for that form.

	You will most likely have one CASE statement below for each form in your
	application.

	@param pEvent A pointer to the event to be handled.

	@return true if the event was handled and does not need to be passed to
	another handler function, false otherwise.
 */
static Boolean AppHandleEvent( EventPtr pEvent );

/** Handles the hierarchy of event passing in the application.

	For example, if an event cannot be handled by a menu's event handler,
	this method will manage the passing of that event up to the application.
 */
static void AppEventLoop( void );

/** Performs necessary population of application variables.

	@return 0 if population completed successfully, nonzero otherwise.
 */
static Err AppStart( void );

/** Clears up memory which was used by the application and writes data 
    to memory.
 */
static void AppStop( void );

/** The main entry point for this application.

	@param cmd The launch code for this application
	@param cmdPBP The paramenter block for this application (this is launch
				  code specific)

	@param launchFlags SysAppLaunch flags passed by the Caller and the OS
					   (see SystemMgr.h)

	@return The exit error code of this application.
			This will be 0 if no errors were encountered, nonzero otherwise.
 */
DWord PilotMain( Word cmd, Ptr cmdPBP, Word launchFlags);

#endif
