/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2001-2003, by iAnywhere Solutions, Inc.         *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/



#include "PalmFunctions.h"


VoidPtr PalmGetObjectPtr( Word object_id )
{
	VoidPtr p;
	FormPtr frm_ptr;

	frm_ptr = FrmGetActiveForm();

	p = FrmGetObjectPtr( frm_ptr, FrmGetObjectIndex( frm_ptr, object_id ) );

	return p;
}


void PalmSetFieldText( Handle & h, Word field_id, TCHAR *text )
{
	FieldPtr pField;
	CharPtr text_ptr;
	Word size;

    // obtain old data pointed to by the handle
    VoidPtr oldHandlePtr = MemHandleLock( h );

	size = StrLen( text );

#if UL_PALMOS_SDK < 35
h = ( TCHAR** ) MemHandleNew( size + 1 );

#else
h = MemHandleNew( size + 1 );

#endif

	text_ptr = ( TCHAR* ) MemHandleLock( h );
	StrCopy( text_ptr, text );

	pField = ( FieldPtr ) PalmGetObjectPtr( field_id );

	FldSetTextHandle( pField, h );
	FldGrabFocus( pField );
	FldDrawField( pField );

	MemHandleUnlock( h );

	// free the old memory reference on the heap
	MemPtrFree( oldHandlePtr );
}


void PalmFreeHandle( Handle h )
{
	if( h != NULL ) {
		MemHandleFree( h );  // TODO: should check return code
                             //       (left as exercise to reader)
	}
}