/*##COPYRIGHT
 ***********************************************************************
 *       Copyright (C) 2001-2003, by iAnywhere Solutions, Inc.         *
 *       All rights reserved. iAnywhere Solutions is a trademark       *
 *       of Sybase, Inc.  No part of this software may be              *
 *       reproduced in any form or by any means - graphic,             *
 *       electronic or mechanical, including photocopying,             *
 *       recording, taping or information storage and retrieval        *
 *       systems - except with the written permission of               *
 *       iAnywhere Solutions, Inc.                                     *
 *                                                                     *
 ***********************************************************************
#*/




#ifndef _PALMFUNCTIONS_H_    // make sure we only include this code once
#define _PALMFUNCTIONS_H_

#if UL_PALMOS_SDK < 35
// For use with PalmOS SDK versions earlier than 3.5 (default)
#include <Pilot.h>

#else
// For use with PalmOS SDK 3.5 and above
#include <PalmOS.h>
#include <PalmCompatibility.h>

#if UL_PALMOS_SDK >= 40
//For use with PalmOS SDK 4.0 and above
#include <PalmUtils.h>
#endif

#endif

#include "platform.h"
#include "ULDB.h"

/** Gets a pointer to the given object on the form which is currently active.

	@param object_id The id number of the object to get a pointer for.

	@return A pointer to the given object.
 */
VoidPtr PalmGetObjectPtr( Word object_id );

/** Allocates a new relocatable memory block (a Handle), copies the given text
	to that memory and sets the given field's text to the new memory.  This
	function can only set fields on the form which is currently active.

	@param field_id The id number of the field whose text is to be set.
	@param text A pointer to the text to set in the given field
    @param h The Handle reference to be set as the newly allocated memory block.
             Any existing memory pointed to by the Handle h is freed before
             any allocations are made. Please note you will need to free this
             Handle when you are done with the field text.             
 */
void PalmSetFieldText( Handle & h, Word field_id, TCHAR *text );

/** Frees the memory pointed to by the given Handle.

	@param h The handle to be freed.
 */
void PalmFreeHandle( Handle h );

#endif
